SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #IncompleteConcreteSubclassesFinderTest
	instanceVariableNames: 'theClass incompleteConcreteSubclassesFinder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:49'!
setUp

	incompleteConcreteSubclassesFinder := IncompleteConcreteSubclassesFinder new.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:51'!
testShouldFailIfAskingForUnknownMethod
	self should: [incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractA notImplementing: #unknown] 
		 raise: Error
		 withExceptionDo: [ :anError | self assert: anError messageText = IncompleteConcreteSubclassesFinder messageNotPresent].! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:52'!
testShouldListDirectSubclassesNotImplementingAbstractMethod
	| subclasses |
	subclasses := incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractB notImplementing: #anAbstractMethod.
	self assert: subclasses size = 1.
	self assert:  (subclasses includes: AbstractSubclassB).! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:53'!
testShouldListNoClasesOnAbstractMethodIfNoSubclasses
	| subclasses |
	subclasses := incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractA notImplementing: #anAbstractMethod.
	self assert: subclasses isEmpty.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:53'!
testShouldListNoClasesOnImplementedMethod
	| subclasses |
	subclasses := incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractA notImplementing: #aConcreteMethod.
	self assert: subclasses isEmpty.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:54'!
testShouldNotListAbstractSubclassesNotImplementingMethod
	| subclasses |
	subclasses := incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractC notImplementing: #anAbstractMethod.
	self assert: (subclasses includes: AbstractSubclassC) not.! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:54'!
testShouldNotListNestedSubclassesImplementingAbstractMethod
	| subclasses |
	subclasses := incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractC notImplementing: #anAbstractMethod.
	self deny: (subclasses includes: NestedConcreteSubclassC).! !

!IncompleteConcreteSubclassesFinderTest methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:54'!
testShouldNotListNestedSubclassesWithInheritedImplementation
	| subclasses |
	subclasses := incompleteConcreteSubclassesFinder concreteSubclassesOf: AbstractC notImplementing: #anotherAbstractMethod.
	self assert: subclasses isEmpty.! !

!Behavior methodsFor: '*Metaprogramacion' stamp: 'JuanEdi 6/20/2013 15:01'!
subclassesNotImplementing: aMessageSelector 
	
	^ (IncompleteConcreteSubclassesFinder new) concreteSubclassesOf: self notImplementing: aMessageSelector.! !

Object subclass: #AbstractA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractA methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:16'!
aConcreteMethod
! !

!AbstractA methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:09'!
anAbstractMethod
	self subclassResponsibility ! !

Object subclass: #AbstractB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:19'!
anAbstractMethod
	self subclassResponsibility ! !

AbstractB subclass: #AbstractSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

AbstractB subclass: #ConcreteSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassB methodsFor: 'as yet unclassified' stamp: 'pb 6/19/2013 20:37'!
anAbstractMethod! !

Object subclass: #AbstractC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:07'!
anAbstractMethod
 	self subclassResponsibility.! !

!AbstractC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod
 	self subclassResponsibility.! !

AbstractC subclass: #AbstractSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AbstractSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod
! !

AbstractSubclassC subclass: #NestedConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!NestedConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:12'!
anAbstractMethod
 	! !

AbstractC subclass: #ConcreteSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:12'!
anAbstractMethod
 	! !

!ConcreteSubclassC methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/19/2013 21:19'!
anotherAbstractMethod! !

Object subclass: #IncompleteConcreteSubclassesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!IncompleteConcreteSubclassesFinder commentStamp: '<historical>' prior: 0!
An IncompleteConcreteSubclassesFinder is xxxxxxxxx.

Instance Variables
!

!IncompleteConcreteSubclassesFinder class methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:51'!
messageNotPresent
	^ 'this class does not respond to this message'.! !

!IncompleteConcreteSubclassesFinder methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:46'!
concreteSubclassesOf: aClass
	^ aClass allSubclasses select: [ :aSubclass | aSubclass subclasses isEmpty ].! !

!IncompleteConcreteSubclassesFinder methodsFor: 'as yet unclassified' stamp: 'JuanEdi 6/20/2013 14:51'!
concreteSubclassesOf: aClass notImplementing: aMessageSelector 
	"Aqu suponemos que aClass es el tope de una jerarqua polimrfica. Nos interesa analizar todas las subclases
	que estn al fondo de esta jerarqua. Estas son las clases que deberan ser efectivamente concretas, y por ende
	quereremos detectar cuando no saben responder a algn mensaje definido en la jerarqua."

	| classesToReturn |
	
	(aClass methodDictionary includesKey: aMessageSelector) ifFalse: [
		self error: IncompleteConcreteSubclassesFinder messageNotPresent 
	].
	
	classesToReturn := Set new.
	
	(self concreteSubclassesOf: aClass) do: [ :aConcreteSubclass |
		aConcreteSubclass classAndMethodFor: aMessageSelector 
							 do: [ :implementingClass :compiledMethod |
									compiledMethod isAbstract ifTrue: [ classesToReturn add: aConcreteSubclass ]
							 ]
							 ifAbsent: [ "Ya chequeamos que self contenga una implementacin" ] 
	].

	^ classesToReturn.! !
